class FramersController < ApplicationController
  # GET /framers
  # GET /framers.xml
  def index
    @framers = Framer.find(:all)

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @framers }
    end
  end

  # GET /framers/1
  # GET /framers/1.xml
  def show
    @framer = Framer.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @framer }
    end
  end

  # GET /framers/new
  # GET /framers/new.xml
  def new
    @framer = Framer.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @framer }
    end
  end

  # GET /framers/1/edit
  def edit
    @framer = Framer.find(params[:id])
  end

  # POST /framers
  # POST /framers.xml
  def create
    @framer = Framer.new(params[:framer])

    respond_to do |format|
      if @framer.save
        flash[:notice] = 'Framer was successfully created.'
        format.html { redirect_to(@framer) }
        format.xml  { render :xml => @framer, :status => :created, :location => @framer }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @framer.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /framers/1
  # PUT /framers/1.xml
  def update
    @framer = Framer.find(params[:id])

    respond_to do |format|
      if @framer.update_attributes(params[:framer])
        flash[:notice] = 'Framer was successfully updated.'
        format.html { redirect_to(@framer) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @framer.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /framers/1
  # DELETE /framers/1.xml
  def destroy
    @framer = Framer.find(params[:id])
    @framer.destroy

    respond_to do |format|
      format.html { redirect_to(framers_url) }
      format.xml  { head :ok }
    end
  end
end
