//= require "jquery"
//= require "jquery-ui"
EtchaBuilder = {
  local:{},
  jsonRep:'',
  columns:'',
  sections:'',
  columnCount:7,
  columnWidth:60,
  columnHeight:177,
  layoutWidth:960,
  gutterWidth:20,
  sliderWidth:120,
  sliderHeight:50,
  lineheight:20,
  current:'',
  init:function(){
    
    // int behaviors
    $('div#builder div#builder-1').show()
    this.Grid.init()
    
    $(this.styleNode).attr("id","css-store")     // define dynamic style sheet
    $(this.metacache).attr("id","metacache")     // define meta script tag
    
    var gridPosition=(((window.innerWidth - EtchaBuilder.layoutWidth) / 2)-7)+"px";
    var marginDefualt = '0 0 '+this.gutterWidth+'px 0'
    Etcha = {  //Set default css values
      body:{type:'element',properties:{}},
      grid:{type:'id',properties:{background:'url(/images/bgrid/'+this.gutterWidth+'.gif)',width:EtchaBuilder.layoutWidth+'px',position:'fixed',left:gridPosition,'min-height':'200px',opacity:'.4'}},
      layout:{type:'id', properties:{width:EtchaBuilder.layoutWidth+'px',margin:'0 auto',border:'1px solid #ccc','min-height':'1000px',overflow:'hidden',opacity:'.5'}},
      blocks:{type:'class', properties:{'float':'left',background:'#DFDFDF', width:'40px'}},
      column:{type:'class',properties:{'float':'left',height:this.columnHeight+'px',width:this.columnWidth+'px','border-top':'1px solid','border-bottom':'1px solid',margin:marginDefualt}},
      gutter: {type:'class',properties:{margin:marginDefualt,height:this.columnHeight+'px',width:EtchaBuilder.gutterWidth+'px','float':'left',opacity:'.4',background:'#9FDDFF','border-top':'1px #000 solid','border-bottom':'1px #000 solid'}}
    }
    
    // build style sheet
    EtchaBuilder.Grid.format()

    $('#layout p,#layout h1,#layout h2,#layout h3,#layout h4').live('mouseover',function(){
      $(this).css({border:'1px solid red'})
    })
    .live('mouseout',function(){
      $(this).css({border:'none'})
    })
    .live('click',function(){
      $(this).css({background:'#FFE4CF'})
      EtchaBuilder.Grid.elect(this)
    })
    .live('dblclick',function(){
      $(this).css({background:'none'})
    })
    // set default events 
    var gridWidth = $("input#grid-width")
    gridWidth
    gridWidth.val(EtchaBuilder.layoutWidth)
    
    gridWidth.live('change', function(e){
      EtchaBuilder.layoutWidth=$('input#grid-width').val();
      EtchaBuilder.Grid.init()
      EtchaBuilder.Grid.cage() })

    // gutter width
    $('input#gutter-width').val(EtchaBuilder.gutterWidth)
    $('input#gutter-width').live('change', function(e){
      EtchaBuilder.gutterWidth=$('input#gutter-width').val();
      EtchaBuilder.Grid.gutterDepth(EtchaBuilder.gutterWidth)
      })

    var padingTop = $('#element-padding-t')
    var padingRight = $('#element-padding-r')
    var padingBottom = $('#element-padding-b')
    var padingLeft = $('#element-padding-l')
    var marginTop =   $('#element-margin-t')
    var marginRight = $('#element-margin-r')
    var marginBottom =$('#element-margin-b')
    var marginLeft =  $('#element-margin-l')
    padingTop.blur(function(){
      selected = $('div.elected')[0].id
      EtchaBuilder.parse({element:selected,property:'padding-top',value:this.value+'px'});
      })
    padingRight.blur(function(){
        selected = $('div.elected')[0].id
        EtchaBuilder.parse({element:selected,property:'padding-right',value:this.value+'px'});
        })
    padingBottom.blur(function(){
          selected = $('div.elected')[0].id
          EtchaBuilder.parse({element:selected,property:'padding-bottom',value:this.value+'px'});
      })
    padingLeft.blur(function(){
        selected = $('div.elected')[0].id
        EtchaBuilder.parse({element:selected,property:'padding-left',value:this.value+'px'});
      })
    marginTop.blur(function(){
      selected = $('div.elected')[0].id
      EtchaBuilder.parse({element:selected,property:'margin-top',value:this.value+'px'});
      })
    marginRight.blur(function(){
        selected = $('div.elected')[0].id
        EtchaBuilder.parse({element:selected,property:'margin-right',value:this.value+'px'});
        })
    marginBottom.blur(function(){
          selected = $('div.elected')[0].id
          EtchaBuilder.parse({element:selected,property:'margin-bottom',value:this.value+'px'});
      })
    marginLeft.blur(function(){
        selected = $('div.elected')[0].id
        EtchaBuilder.parse({element:selected,property:'margin-left',value:this.value+'px'});
      })      
    // elect blocks
    $('div.blocks').live('click',function(){EtchaBuilder.Grid.elect(this) })  // listen to block events
    
    // click events
    $('#merge').live('click',function(){EtchaBuilder.Grid.mergeColumns()})             // merge
    $('#insert-row').live('click',function(){EtchaBuilder.Grid.insert()})              // add row
    $('#remove').live('click',function(){EtchaBuilder.Grid.discard()})                 //remove element
    $('#export-markup').live('click',function(){EtchaBuilder.Export.strip()})          //remove element
    
    
    // toggles
    $('#toggle-grid').click(function(){$('#grid').toggle()})
    $('#toggle-boxes').click(function(){
       ($('div.blocks').hasClass('clean')) ? $('div.blocks').removeClass('clean') :$('div.blocks').addClass('clean')
      })
      
      
    // register close event
    this.Typography.init()
    this._close()
    this.Grid.raster(180) //build grid
  },
  Grid:{
    init:function(){
      //   slide events
          
      $("#column-width").slider({range:"min",value:7,min:.1,max:200,
        slide:function(event,ui){
        $("#column-widths").val(Math.round(ui.value));
        EtchaBuilder.Grid.columnStretch(Math.round(ui.value))
        }
      })
      $("#column-height").slider({range:"min",value:7,min:1,max:200,
        slide:function(event,ui){
        $("#column-heights").val(Math.round(ui.value));
        EtchaBuilder.Grid.columnRaise(Math.round(ui.value))
        }
      })
      
 
    },
    raster:function(count){
      for (var i = count - 1; i >= 0; i--){
         $('<div class="column"></div><div class="gutter"></div>').appendTo($('#grid'))
      };
    },
    columnStretch:function(w){
      Etcha.column.properties.width = w+"px"
      this.format()
    },
    columnRaise:function(h){

      Etcha.column.properties.height = h+"px"
      Etcha.gutter.properties.height = h+"px"
      this.format()
    },
    gutterDepth:function(h){

      Etcha.gutter.properties.width = h+"px"
      Etcha.grid.properties.background = "url(/images/bgrid/"+h+".gif)"
      Etcha.gutter.properties.margin = '0 0 '+h+'px 0'
      Etcha.column.properties.margin = '0 0 '+h+'px 0'
     
      jQuery.each(Etcha, function(i,val){
        if(Etcha[i].create) {
          Etcha[i].properties.margin = '0 '+h+'px '+h+'px 0'
        }
      })
      this.format()
    },
    mergeColumns:function(){
      n = $('div.elected').length
      newColWidth = n * EtchaBuilder.sliderWidth
      EtchaBuilder.section = {}
      EtchaBuilder.Grid.columns.build({count:EtchaBuilder.columnCount,section:newColWidth,withHold:n})
      // $('<div id="blocks col-'+i+'">column '+i+'</div>').appendTo($('#layout')) 
      $('div.elected').remove()
    },
    elect:function(el){
      // add in shift click for merge and ratio
      $('div.blocks').removeClass('elected')
      $(el).hasClass('elected') ? $(el).removeClass('elected') : $(el).addClass('elected')  // choose column/element
    },
    cage:function(){
      Etcha.layout.properties.width = EtchaBuilder.layoutWidth+"px"
      Etcha.grid.properties.width = EtchaBuilder.layoutWidth+"px"
      Etcha.grid.properties.left = (((window.innerWidth - EtchaBuilder.layoutWidth) / 2)-7)+"px";
      this.format()
    },
    stretch:function(w){
      // TODO:Cleanup Redundant code blocks between raise and stretch
      stretchHash = $.evalJSON($('#metacache').text())
      $('div.elected').each(function(s){
         el = this.id 
         jQuery.each(stretchHash, function(i,val){
            if (i == el) {stretchHash[i].properties.width = w+"px" }
          })
      })
       
      EtchaBuilder.metabuild($.toJSON(stretchHash))
      this.format()
    },
    raise:function(h){
      // TODO:Cleanup Redundant code blocks between raise and stretch
      stretchHash = $.evalJSON($('#metacache').text())
      $('div.elected').each(function(s){
         el = this.id 
         jQuery.each(stretchHash, function(i,val){
            if (i == el) {stretchHash[i].properties.height = h+"px" }
          })
      })
       
      EtchaBuilder.metabuild($.toJSON(stretchHash))
      this.format()
    },
    insert:function(){

      children='children'
      has_elect = $('div.elected')[0]
      
      var margin = '0 '+EtchaBuilder.gutterWidth+'px '+EtchaBuilder.gutterWidth+'px 0' 
      newElementId = $('#element-name').attr('value') //input

      if(has_elect !=undefined){
          jQuery.each(Etcha, function(i,val){
             if (i == has_elect.id) {
               
               if(!Etcha[has_elect.id].children){Etcha[has_elect.id][children]={}}
               Etcha[has_elect.id][children][newElementId]={type:'id',properties:{
                            width:EtchaBuilder.sliderWidth+'px',
                            height: EtchaBuilder.sliderHeight+'px',
                            margin:margin,
                            border:'1px solid',
                            overflow:'hidden'}}
               EtchaBuilder.Grid.create({id:newElementId,parent:'#'+has_elect.id})
               $('#'+has_elect.id).removeClass('elected')
               }
           })
             
      }else{
        if(this.validateElement(newElementId)){
          Etcha[newElementId]={type:'id', create:true, properties:{width:EtchaBuilder.sliderWidth+'px',height: EtchaBuilder.sliderHeight+'px',margin:margin,border:'1px solid',overflow:'hidden'}}
          EtchaBuilder.Grid.create({id:newElementId,parent:'#layout'})
          }
      }//end has_elect
      
    },
    resizes:function(el){
      $('#'+el).resizable({
           ghost:true,
           grid:[EtchaBuilder.sliderWidth,EtchaBuilder.sliderHeight],
           // containment:'#layout',
           stop:function(){
            //refactor redundant!
           var h= $(this).height() + "px"
           var w= $(this).width() + "px"
           var cur = this.id
           jQuery.each(Etcha, function(i,val){
              if (i == cur) {
                Etcha[i].properties.width = w 
                Etcha[i].properties.height = h
                }
            })
            
            EtchaBuilder.Grid.format()
           
      }})
    },
    discard:function(){
      
      $('div.elected').each(function(s){
         el = this.id 
         jQuery.each(Etcha, function(i,val){
            if (i == el) {delete Etcha[i] }
          })
      })
      $('div.elected').remove()
      this.format()
    },
    create:function(newEl){
      $('#element-name').val('')
      $('<div id='+newEl.id+' class="blocks"><div class="content">'+newEl.id+'</div></div>').appendTo($(newEl.parent))
      EtchaBuilder.Grid.resizes(newEl.id)
      
      $('#'+newEl.id).live('dblclick',function(){$(this).removeClass('elected')})
          
      this.format()
    },
    gutter:function(col){
      // TODO: FINISH THIS - DROP GUTTER IF AT END AND COLUMN DOSEN'T BREAK
      gutterReach = EtchaBuilder.sliderWidth * EtchaBuilder.columnCount + EtchaBuilder.gutterWidth 
      allowGutter = (gutterReach > EtchaBuilder.layoutWidth) ? true : false 
      this.rowCount= allowGutter ? col + 1 : 0
      // console.log(this.rowCount)
      col=null
    },
    format:function(){

      var parsedCSS='';
      var props=''; 
      
      jQuery.each(Etcha, function(i,val){
         css = val.properties
         children = val.children
         jQuery.each(css, function(i,val){
            props+=i.replace('_','-')+':'+val+';'
         })
         if(children){
         jQuery.each(children, function(i,val){
           childCSS=val.properties
           jQuery.each(childCSS, function(i,val){
              props+=i.replace('_','-')+':'+val+';'
           })
         })
         }//endif
         parsedCSS += EtchaBuilder.Grid.propertyKind(i,val.type) + '{'+props+'} '
         props=''; 
      })
       $("#css-store").empty(); //clear latyout rebuild
       // regex the layoutwidth
       $("#css-store").text(parsedCSS);
       // $("#metacache").text(EtchaBuilder.sections)
       EtchaBuilder.Export.init()
       
    },
    propertyKind:function(key,type){
      return (type == 'class')? '.'+key : '#'+key
    },
    validateElement:function(element){
       var pass = true
       jQuery.each(Etcha, function(i,val){
          if (i == element) { 
             pass = false;
             return false
             }
        })
        if(element =='') {pass=false;}
        if(!pass) {
            msg = (element != '') ? element+': has already been declared, try another name' : 'Please enter a for your new block'
            alert(msg)
        }
        return pass  
        
    }
  },
  Typography:{
    init:function(){
      
      $('#typeface').live('change',function(){
         var el;
         if($('.elected').length >0) {
           el= $('.elected')[0].id
           if(el == '') el = $('.elected')[0].nodeName.toLowerCase(); 
           }
           el = (el !=undefined) ? el : 'body'
         EtchaBuilder.parse({element:el,property:'font-family',value:this.value})
       })
      
      $('#weight').live('change',function(){
         var el;
         if($('.elected').length >0) {el= $('.elected')[0].id}
         el = (el !=undefined) ? el : 'body'
         EtchaBuilder.parse({element:el,property:'font-weight',value:this.value})
      })

      $('#edit-element').live('click', function(){
        EtchaBuilder.Typography.transport()
      })
      
      $("#tracking").slider({orientation: "horizontal",value: 0,min:-10,max:20,
          slide:function(event,ui){
          if($('div.elected').length >0) {el= $('div.elected')[0].id}  
          $("#trackings").val(ui.value);
         EtchaBuilder.parse({element:el,property:'letter-spacing',value:ui.value+'px'})
          }
        })
      $("#leading").slider({orientation: "horizontal",value: 3,min:0,max:10, step:.1,
        slide:function(event,ui){
        if($('div.elected').length >0) {el= $('div.elected')[0].id}  
        $("#leadings").val(ui.value);
         EtchaBuilder.parse({element:el,property:'line-height',value:ui.value})
        }
      })
    
      
    },
    transport:function(){
      
      $('div.elected').each(function(e){
        
        $('#'+this.id+' div.content').html($('#transport-text').val())
        })
    }
  },
  Export:{
    init:function(){
        $('#export-css').val($('#css-store').html())
    },
    strip:function(){
      layout = $('#layout').clone()
      layout.children().each(function(){
        this.removeAttribute('style')
        if($(this).hasClass('ui-resizable')) $(this).removeClass('ui-resizable')
        $(this).children().each(function(){
          if($(this).attr('unselectable')) $(this).remove()
        })

      })
      $('#export-markup').val(layout.html())
    },
  },
  parse:function(cssOptions){
    jQuery.each(Etcha, function(i,val){
         if (i == cssOptions.element) {      
            Etcha[i].properties[cssOptions.property] = cssOptions.value
         }
     })
    EtchaBuilder.Grid.format()
   },
  _close:function(){
    $('#close').live('click',function(){$('div#builder').hide()})
  }
};

$(document).ready(function(){
  $('#heroku_toolbar').remove()
  $('div#builder div.pane').hide()
  $('ul#beahviors li a').click(function(){
    $('div#builder').show()
    $('div#builder div.pane').hide()
    pane = $(this).attr('href');
    $(pane).show()
  })
  
  EtchaBuilder.init()
  
});
